SystemOrganization addCategory: #'Bioloid-Etoys-Wiring'!
SystemOrganization addCategory: #'Bioloid-Etoys-Devices'!
SystemOrganization addCategory: #'Bioloid-Etoys'!

Player subclass: #BioloidPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bioloid-Etoys'!

!BioloidPlayer methodsFor: 'connection' stamp: 'Sgb 10/22/2012 17:33'!
connect
self sendMessageToCostume: #connect! !

!BioloidPlayer methodsFor: 'connection' stamp: 'Sgb 10/22/2012 17:43'!
disconnect
self sendMessageToCostume: #disconnect! !

!BioloidPlayer methodsFor: 'connection' stamp: 'sgb 10/24/2012 16:21'!
getIsConnected
^ self sendMessageToCostume: #isConnected! !

!BioloidPlayer methodsFor: 'connection' stamp: 'sgb 10/24/2012 16:11'!
getPortName
^ self getValueFromCostume: #portName ! !

!BioloidPlayer methodsFor: 'connection' stamp: 'sgb 10/24/2012 16:11'!
setPortName:aNumber
self setCostumeSlot: #portName: toValue: aNumber
! !

Player subclass: #MotorPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bioloid-Etoys-Devices'!

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/26/2012 16:06'!
getGoalPosition
^ self sendMessageToCostume: #goalPosition! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/24/2012 17:18'!
getId
^ self sendMessageToCostume: #getId! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/26/2012 16:12'!
getIsLedOn 
^ self sendMessageToCostume: #led

! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/30/2012 17:31'!
getMovingSpeed
^ self sendMessageToCostume: #movingSpeed! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/30/2012 17:21'!
getTorqueEnable
^ self sendMessageToCostume: #torqueEnable

! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/30/2012 17:36'!
getTorqueLimit
^ self sendMessageToCostume: #torqueLimit! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/24/2012 17:22'!
setGoalPosition: aNumber
self setCostumeSlot: #goalPosition: toValue: aNumber! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/26/2012 16:13'!
setIsLedOn: aBoolean 
	self sendMessageToCostume: #led: with: aBoolean

! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/30/2012 17:30'!
setMovingSpeed: aNumber
self setCostumeSlot: #movingSpeed: toValue: aNumber! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/30/2012 17:22'!
setTorqueEnable: aBoolean 
	self sendMessageToCostume: #torqueEnable: with: aBoolean

! !

!MotorPlayer methodsFor: 'connection' stamp: 'sgb 10/30/2012 17:36'!
setTorqueLimit: aNumber
self setCostumeSlot: #torqueLimit: toValue: aNumber! !

Morph subclass: #BioloidMorph
	instanceVariableNames: 'bioloid portName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bioloid-Etoys'!

BioloidMorph class
	instanceVariableNames: 'lastPortName form'!

BioloidMorph class
	instanceVariableNames: 'lastPortName form'!

!BioloidMorph class methodsFor: 'additionToViewerCategories' stamp: 'sgb 10/24/2012 16:20'!
additionsToViewerCategories
^ # (

(#'bioloid - connection'(
	(command connect '')
   (command disconnect'')
	
#(slot portName 'Name of the OS port in which the device is connected' PEPort readWrite Player getPortName Player setPortName: )

#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )


))

)! !

!BioloidMorph class methodsFor: 'parts bin' stamp: 'sgb 10/29/2012 16:07'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Bioloid' translatedNoop
		categories: ((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation: 'An object that lets you communicate with a Bioloid' translatedNoop! !

!BioloidMorph class methodsFor: 'form' stamp: 'sgb 10/26/2012 15:39'!
form
	^form ifNil: [self initializeForm]! !

!BioloidMorph class methodsFor: 'form' stamp: 'sgb 10/26/2012 15:34'!
initializeForm
^form := PEUtilities formFromEncodedPNG:   'iVBORw0KGgoAAAANSUhEUgAAAU4AAADUCAYAAADz2cr4AAAABHNCSVQFBQUBSsjp7wAAF/FJ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=='! !

!BioloidMorph class methodsFor: 'additionToViewerCategories' stamp: 'sgb 10/24/2012 16:05'!
lastPortName
"
	lastPortName := nil.
"
^lastPortName! !

!BioloidMorph class methodsFor: 'additionToViewerCategories' stamp: 'sgb 10/24/2012 16:06'!
lastPortName: aSymbol
lastPortName := aSymbol! !

!BioloidMorph methodsFor: 'viewer category filter' stamp: 'sgb 10/29/2012 18:29'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!BioloidMorph methodsFor: 'accessing' stamp: 'sgb 10/24/2012 15:47'!
connect
bioloid connectOnPort:portName
! !

!BioloidMorph methodsFor: 'initializing' stamp: 'sgb 10/24/2012 15:45'!
delete
self isConnected ifTrue: [self disconnect].
super delete.! !

!BioloidMorph methodsFor: 'accessing' stamp: 'sgb 10/24/2012 15:49'!
disconnect
bioloid disconnect
! !

!BioloidMorph methodsFor: 'drawing' stamp: 'sgb 10/26/2012 15:40'!
drawOn: aCanvas
	aCanvas translucentImage: self class form at: self bounds topLeft! !

!BioloidMorph methodsFor: 'initializing' stamp: 'sgb 10/26/2012 16:22'!
initialize
	super initialize.
	self extent: self class form extent.
	bioloid := Bioloid new.
	self initializePortName.
	self initializePins! !

!BioloidMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 16:58'!
initializePins
	{"{center. extent}"
		{-161 @ 46. 8 @ 42}.
		{-97 @ 99. 42 @ 8}.
		{100 @ 99. 42 @ 8}.
		{161 @ 46. 8 @ 42}
	}
	do: [:spec || bpm |
		bpm := BioloidPinMorph on: bioloid.
		bpm extent: spec second;
			center: self center + spec first;
			repositionAttachmentPoint.
		self addMorph: bpm]! !

!BioloidMorph methodsFor: 'initializing' stamp: 'sgb 10/24/2012 15:43'!
initializePortName
| availablePorts |
	availablePorts := PESerialPort availablePorts.
	(availablePorts includes: self class lastPortName)
		ifFalse: [self class lastPortName: availablePorts first].
	portName := self class lastPortName
! !

!BioloidMorph methodsFor: 'accessing' stamp: 'sgb 10/24/2012 16:18'!
isConnected
^bioloid isConnected! !

!BioloidMorph methodsFor: 'accessing' stamp: 'Sgb 10/22/2012 17:30'!
newPlayerInstance
^BioloidPlayer newUserInstance

! !

!BioloidMorph methodsFor: 'accessing' stamp: 'sgb 10/24/2012 16:13'!
portName
^portName! !

!BioloidMorph methodsFor: 'accessing' stamp: 'sgb 10/24/2012 16:13'!
portName:aNumber
portName:=aNumber! !

!BioloidMorph methodsFor: 'viewer category filter' stamp: 'sgb 10/29/2012 18:29'!
validCategories
^(self class additionsToViewerCategories collect: [:each| each first])! !

Morph subclass: #BioloidPinMorph
	instanceVariableNames: 'bioloid attachmentPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bioloid-Etoys'!

!BioloidPinMorph class methodsFor: 'devices' stamp: 'sgb 10/29/2012 18:04'!
devices
^{MotorMorph}! !

!BioloidPinMorph class methodsFor: 'instance creation' stamp: 'sgb 10/26/2012 16:31'!
on: aBioloid
	^ self basicNew initializeWith: aBioloid! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 15:59'!
attachNewDevice
	| newDevice |
	newDevice := self newDevice.
	newDevice center: self center.
	newDevice openInWorld.
	self attach: newDevice! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:33'!
attach: deviceMorph 
	| wire |
	wire := deviceMorph class newConnectorFromMorph: attachmentPoint toMorph: deviceMorph attachmentPoint.
	deviceMorph attach: bioloid by: wire.
	self move: deviceMorph! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 15:53'!
canBeAttachedTo: aMorph 
	self class devices
		do: [:each | (aMorph isKindOf: each)
				ifTrue: [^ true]].
	^ false! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 17:56'!
connectedToBy: aConnector 
	"notification upon connection by a NCConnectorMorph"
	| device |
	aConnector connectFinishTo: attachmentPoint.
	aConnector startControllingConnections.
	device := aConnector sourceMorph owner.
	device attach: bioloid by: aConnector
! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:01'!
controlDeviceBounds: aDevice
	aDevice top < World top
		ifTrue: [aDevice top: World top].
	aDevice left < World left
		ifTrue: [aDevice left: World left].
	aDevice bottom > (World bottom - 25)
		ifTrue: [aDevice bottom: World bottom - 25].
	aDevice right > World right
		ifTrue: [aDevice right: World right]
! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 17:57'!
disconnectedFromBy: aConnector
[
aConnector destinationMorph ifNotNilDo: [:m | m owner detach].
aConnector sourceMorph ifNotNilDo: [:m | m owner detach].]
on: Error do: []! !

!BioloidPinMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 16:50'!
initialize
	super initialize.
	self color: Color white;
		initializeAttachmentPoint;
		initializeEventHandling! !

!BioloidPinMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 16:57'!
initializeAttachmentPoint
	attachmentPoint := PEAttachmentPointMorph new color: Color transparent;
				 borderWidth: 0;
				 extent: 1 @ 1.
	self addMorph: attachmentPoint! !

!BioloidPinMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 15:57'!
initializeEventHandling
	self
		on: #mouseEnter
		send: #mouseEnter:forMorph:
		to: self;		
		on: #mouseLeave
		send: #mouseLeave:forMorph:
		to: self;
		on: #mouseDown
		send: #mouseDown:forMorph:
		to: self.! !

!BioloidPinMorph methodsFor: 'initializing' stamp: 'sgb 10/26/2012 16:31'!
initializeWith: aBioloid
	bioloid := aBioloid.
	self initialize! !

!BioloidPinMorph methodsFor: 'event handling' stamp: 'sgb 10/29/2012 17:55'!
mouseDown: evt forMorph: aMorph 
	self attachNewDevice! !

!BioloidPinMorph methodsFor: 'event handling' stamp: 'sgb 10/29/2012 17:58'!
mouseEnter: evt forMorph: aMorph 
	self color: Color lightBlue.
	! !

!BioloidPinMorph methodsFor: 'event handling' stamp: 'sgb 10/29/2012 17:58'!
mouseLeave: evt forMorph: aMorph 
	self color: Color white. ! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:17'!
move: aDevice 
	aDevice 
		bottom: self top - 50;
		left: self left - 50.
	self controlDeviceBounds: aDevice! !

!BioloidPinMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:00'!
newDevice
	^MotorMorph new ! !

!BioloidPinMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 16:57'!
repositionAttachmentPoint
	attachmentPoint center: self center! !

!BioloidPinMorph methodsFor: 'private' stamp: 'sgb 10/29/2012 15:55'!
wantsAttachmentFromEnd: endIndex ofConnector: aConnector
"Little hack to consider shift always pressed and be able to connect to pins (which are submorphs)"
	"Answer true if I would like the given end of aConnector attaching to me."
	"TODO: way too much policy in this one place!!"

	owner ifNil: [ ^false ].	
	self == aConnector ifTrue: [ ^false ].
	self isConnectable ifFalse: [ ^false ].
	(self firstOwnerSuchThat: [ :m | m == aConnector ]) ifNotNil: [ ^false ].
	(self isConstrainedBy: aConnector) ifTrue: [ ^false ].
	self isPartsDonor ifTrue: [ ^false ].

	"Allow connection to submorphs when the SHIFT key is pressed, but only to top-level morphs"
	("ActiveHand lastEvent shiftPressed not" false
		and: [ self topRendererOrSelf owner isPlayfieldLike not ])
			ifTrue: [ ^false ].

	"Avoid connecting from a different World (WiW exception)"
	aConnector pasteUpMorphOrWorld ifNotNilDo: [ :itsWorld |
		(itsWorld isPartsBin not
			and: [ itsWorld ~= World
			and: [ self pasteUpMorphOrWorld ~~ itsWorld ]])
				ifTrue: [ ^false ]].
^true
! !

Morph subclass: #MotorMorph
	instanceVariableNames: 'id motor attachmentPoints attachments label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bioloid-Etoys-Devices'!

MotorMorph class
	instanceVariableNames: 'form'!

MotorMorph class
	instanceVariableNames: 'form'!

!MotorMorph class methodsFor: 'additionToViewerCategories' stamp: 'sgb 10/30/2012 17:37'!
additionsToViewerCategories
^ # (

(#'motor - movement'(

#(slot goalPosition 'You can set the degrees of this motor' Number readWrite Player getGoalPosition Player setGoalPosition:  )

#(slot torqueLimit 'You can set the torque limit of this motor' Number readWrite Player getTorqueLimit Player setTorqueLimit:  )

#(slot movingSpeed 'You can set the moving speed of this motor' Number readWrite Player getMovingSpeed Player setMovingSpeed:  )

#(slot isTorqueEnable 'Checks if the torque is enabled' Boolean readWrite Player getTorqueEnable Player setTorqueEnable: )

)) 

(#'motor - data'(
	
#(slot isLedOn 'Checks if the led is on' Boolean readWrite Player getIsLedOn Player setIsLedOn: )



 ))







)! !

!MotorMorph class methodsFor: 'form' stamp: 'sgb 10/26/2012 15:44'!
form
	^form ifNil: [self initializeForm]! !

!MotorMorph class methodsFor: 'form' stamp: 'sgb 10/26/2012 15:44'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAGUAAACaCAYAAACwuIYDAAAABHNCSVQFBQUBSsjp7wAAEOxJ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'  ! !

!MotorMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 10/29/2012 17:54'!
newConnector
	^ (BioloidWireMorph new) lineColor: Color gray; yourself! !

!MotorMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 10/29/2012 16:15'!
newConnectorFromMorph: m1 toMorph: m2 
^ (BioloidWireMorph fromMorph: m1 toMorph: m2) 
				 lineColor: Color gray;
				yourself! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:09'!
attachMotorTo: aBioloid
	aBioloid attach: motor. ! !

!MotorMorph methodsFor: 'attachment points' stamp: 'sgb 10/29/2012 16:08'!
attachmentPoint
^attachmentPoints first! !

!MotorMorph methodsFor: 'attachment points' stamp: 'sgb 10/29/2012 16:10'!
attachmentPointAt: index
	^attachmentPoints at: index! !

!MotorMorph methodsFor: 'attachment points' stamp: 'sgb 10/29/2012 16:45'!
attachmentPointsSpecs
	^ {
		"{#center. #color. #borderColor}"
		{self center + (-16@4). Color transparent. Color transparent}.
		"{self center + (9@0). Color red. Color gray}"
	}! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:34'!
attach: something by: anArduinoWireMorph 
	| index |
	index := attachmentPoints indexOf: anArduinoWireMorph sourceMorph ifAbsent: [1].
	attachments at: index put: something.
	self refreshDeviceAttachments

! !

!MotorMorph methodsFor: 'viewer category filter' stamp: 'sgb 10/29/2012 18:30'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!MotorMorph methodsFor: 'event handling' stamp: 'sgb 10/29/2012 18:32'!
changeId
	| newId |
	newId := (FillInTheBlank request: 'ID:' translated) asInteger.
	newId = nil ifTrue: [^ self].
	self id: newId
	! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 17:53'!
detachDevice
	motor isAttached ifTrue: [motor detach].! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 17:53'!
detach: aBioloidWireMorph 
	| index |
	index := attachmentPoints
				indexOf: aBioloidWireMorph sourceMorph 
				ifAbsent: [attachmentPoints 	
								indexOf: aBioloidWireMorph destinationMorph 
								ifAbsent: [^ self]].
	(self isAttachedAt: index) ifTrue: [
		attachments at: index put: nil.
		self refreshDeviceAttachments] ! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 16:08'!
disconnectedFromBy: aConnector
	self detach: aConnector! !

!MotorMorph methodsFor: 'drawing' stamp: 'sgb 10/26/2012 15:41'!
drawOn: aCanvas
	aCanvas translucentImage: self class form at: self bounds topLeft! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/26/2012 16:10'!
goalPosition
	^motor goalPosition 
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/26/2012 16:10'!
goalPosition:aNumber
	motor goalPosition: aNumber 
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/29/2012 18:26'!
id: newId
	motor id: newId.
	label contents: newId asString! !

!MotorMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 18:12'!
initialize
	super initialize.
	self extent: self class form extent.
	self initializeAttachmentPoints.
	motor := BioloidMotor id: 1.
	self initializeLabel


! !

!MotorMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 16:11'!
initializeAttachmentPoints
	attachments := Array new: self numberOfAttachmentPoints.
	attachmentPoints := Array streamContents: [:stream |
		1 to: self numberOfAttachmentPoints do: [:i |
			| point spec pointCenter pointColor pointBorderColor |
			spec := self attachmentPointsSpecs at: i.
			pointCenter := spec first.
			pointColor := spec second.
			pointBorderColor := spec third.
			point :=PEAttachmentPointMorph new 
					extent: 10 @ 10;
					center: pointCenter;
					color: pointColor;
					borderColor: pointBorderColor;
					on: #mouseDown
					send: #mouseDownPin:evt:morph:
					to: self
					withValue: i.
			self addMorph: point.
			stream nextPut: point]]! !

!MotorMorph methodsFor: 'initializing' stamp: 'sgb 10/29/2012 18:17'!
initializeLabel
	| container |
	container := Morph new
		color: Color white;
		extent: 21@22;
		center: self center + (0@41);
		on: #mouseDown
		send: #changeId
		to: self;
		yourself.
	label := motor id asMorph.
	label center: container center.
	self addMorph: container.
	container addMorph: label.

! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 17:52'!
isAttachedAt: index
	"Note: This doesn't test if the device is attached at the pin number. Instead, it tests if it is connected (in the morph sense) via the attachment at the given index.
	DO NOT CONFUSE!!"

	^(attachments at: index) notNil! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/26/2012 16:12'!
led
	^motor led
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/26/2012 16:11'!
led: aBoolean
	motor led: aBoolean 
! !

!MotorMorph methodsFor: 'event handling' stamp: 'sgb 10/29/2012 18:07'!
mouseDownPin: attachmentPointIndex evt: evt morph: attachmentPoint
	(self isAttachedAt: attachmentPointIndex)
		ifTrue: [^ self].
	self class newConnector startWiringFrom: attachmentPoint! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/30/2012 17:33'!
movingSpeed
	^motor movingSpeed 
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/30/2012 17:34'!
movingSpeed:aNumber
	motor movingSpeed: aNumber 
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/24/2012 18:06'!
newPlayerInstance
^MotorPlayer newUserInstance! !

!MotorMorph methodsFor: 'attachment points' stamp: 'sgb 10/29/2012 16:10'!
numberOfAttachmentPoints
	^ self attachmentPointsSpecs size! !

!MotorMorph methodsFor: 'attaching' stamp: 'sgb 10/29/2012 17:51'!
refreshDeviceAttachments
	| bioloid |
	bioloid := attachments
		detect: [:each | each isKindOf: Bioloid]
		ifNone: [self detachDevice. ^ self].
	motor attachTo: bioloid! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/30/2012 17:24'!
torqueEnable
	^motor torqueEnable
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/30/2012 17:25'!
torqueEnable: aBoolean
	motor torqueEnable: aBoolean 
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/30/2012 17:41'!
torqueLimit
	^motor torqueLimit 
! !

!MotorMorph methodsFor: 'accessing' stamp: 'sgb 10/30/2012 17:41'!
torqueLimit:aNumber
	motor torqueLimit: aNumber 
! !

!MotorMorph methodsFor: 'viewer category filter' stamp: 'sgb 10/29/2012 18:30'!
validCategories
^(self class additionsToViewerCategories collect: [:each| each first])! !

PEWireMorph subclass: #BioloidWireMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bioloid-Etoys-Wiring'!

!BioloidWireMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 10/29/2012 16:22'!
validConnectionClasses

	^ super validConnectionClasses,
		{BioloidPinMorph. MotorMorph}! !

!BioloidWireMorph methodsFor: 'as yet unclassified' stamp: 'sgb 10/29/2012 16:21'!
enterHandlingDrop
"Little hack to consider shift always pressed and be able to connect to pins (which are submorphs)"
	| potentialConnections nextConnection potentialTargets firstTarget |
	self log: #debug items: { 'enterHandlingDrop' }.
	
	"Find which ends we should potentially try to connect"
	potentialConnections := constraints select: [:ea | ea input isNil].
	potentialTargets := potentialConnections collect: [ :constraint |
		| localPoint targets |
		localPoint := self griddedPoint: constraint targetPoint.
		targets := self connectionTargetsAt: localPoint for: constraint.

		targets notEmpty 
			ifTrue: [ { ("Sensor shiftPressed " true
						ifFalse: [targets first ]
						ifTrue: [ targets last]). localPoint } ]
				ifFalse: [ { nil. nil } ]].

	self isWiring ifTrue: [
		potentialConnections size = 2 ifTrue: [
			firstTarget := potentialTargets findFirst: [ :arr | arr first notNil ].
			firstTarget = 0 ifTrue: [ firstTarget := 1 ].
			nextConnection := potentialConnections atWrap: firstTarget + 1.
			potentialConnections := potentialConnections copyFrom: firstTarget to: firstTarget.
			potentialTargets := potentialTargets copyFrom: firstTarget to: firstTarget
		]].

	potentialConnections with: potentialTargets do: 
			[:constraint :targetAndPoint | 
			| localPoint target |
			target := targetAndPoint first.
			localPoint := targetAndPoint second.
			target isNil
				ifFalse: [ constraint attachTo: target at: localPoint ]
				ifTrue: [ constraint connectToNothing; forceRedraw]].
	self
		changed;
		layoutChanged.

	(self isWiring and: [nextConnection notNil]) 
		ifTrue: 
			[| evt pos |
			evt := ActiveHand lastEvent.
			pos := self griddedPoint: (self globalPointToLocal: evt position).
			potentialConnections first lastTargetPoint: pos.
			nextConnection center: pos.
			self setProperty: #triggeredWireFinish toValue: pos.
			self trigger: #wireFinish
				withArguments: { 
						nextConnection.
						evt}].
! !

!BioloidWireMorph methodsFor: 'initialization' stamp: 'sgb 10/29/2012 16:21'!
initialize
super initialize.
self beOrthogonal: false;
		 beSmoothCurve: true;
		 lineColor: Color red;
		 lineWidth: 4;
		 borderWidth: 1;
		 borderColor: Color gray;
		 yourself! !

!BioloidWireMorph methodsFor: 'as yet unclassified' stamp: 'sgb 10/29/2012 16:21'!
monitorDestinationForEnds
"Little hack to consider shift always pressed and be able to connect to pins (which are submorphs)"
	| targets cTargets |
	targets := IdentitySet new.
	constraints
		do: [:aConstraint | 
			| constraintInput | 
			constraintInput := aConstraint input.
			(constraintInput isNil
					or: [constraintInput isHandMorph])
				ifTrue: [cTargets := self
								connectionTargetsAt: (self visible
										ifTrue: [aConstraint center]
										ifFalse: [ActiveHand position])
								for: aConstraint.
					cTargets isEmpty
						ifFalse: [targets
								add: ("ActiveHand lastEvent shiftPressed"true
										ifTrue: [cTargets last]
										ifFalse: [cTargets first])]]].
	self
		newCursor: (targets isEmpty
				ifTrue: [Cursor crossHair]
				ifFalse: [Cursor webLink]).
	self
		valueOfProperty: #highlightedTargets
		ifPresentDo: [:ht | (ht difference: targets)
				do: [:ea | ea highlightForConnection: false]].
	targets
		do: [:ea | ea highlightedForConnection
				ifFalse: [ea highlightForConnection: true]].
	self setProperty: #highlightedTargets toValue: targets.
	^ targets isEmpty not! !

!BioloidWireMorph methodsFor: 'as yet unclassified' stamp: 'sgb 10/29/2012 16:21'!
wantsToAttachEnd: index toMorph: aMorph 
	(super wantsToAttachEnd: index toMorph: aMorph)
		ifFalse: [^ false].
	^ [aMorph canBeAttachedTo: self sourceMorph owner] on: Error do: [false]! !
